/*
 * Partially implemented disassembler for Samsung SSP160x processors
 * (C) Copyright 2007-2008, Grazvydas "notaz" Ignotas
 */

#ifndef _SSP_HPP
#define _SSP_HPP

#include "../idaidp.hpp"
#include "ins.hpp"


/************************************************************************/
/* Registers (we'll be handling these with custom code )                */
/************************************************************************/

extern char *ssp_reg_names[32+8+8+2];

enum ssp_registers {
  r0, rX, rY, rA, rST, rSTACK, rPC, rP,
  rVcs = 48, rVds = 49           // these 2 registers are required by the IDA kernel
};


/************************************************************************/
/* Common functions                                                     */
/************************************************************************/
void idaapi header(void);
void idaapi footer(void);
void idaapi segstart(ea_t ea);
int idaapi ana(void);
int idaapi emu(void);
void idaapi out(void);
bool idaapi outop(op_t &op);
void idaapi out_data(ea_t ea);

#endif
